function data = mvpa_di_apply_PAAC_protein(data_path)
% label = load(label_path);
% if(isempty(di_param))
%     lambda = 5;
%     weight = 0.05;
%     type = 1;
%     PseAA_used = [1;1;1;0;0;0];
% else
%     lambda = di_param(1);
%     weight = di_param(2);
%     type = di_param(3);
%     PseAA_used = di_param(4:end);
% end
di_param = 5;
lambda = 5;
    weight = 0.05;
    type = 1;
    PseAA_used = [1;1;1;0;0;0];
data_info = di_param;
protein = 'ACDEFGHIKLMNPQRSTVWY';
m_path = mfilename('fullpath');
% load([m_path(1:end-20),filesep,'PseAA_value.mat'],'PseAA_value');
load('PseAA_value.mat','PseAA_value');
PseAA_value = PseAA_value(:,logical(PseAA_used'));
for i = 1:size(PseAA_value,2)
    PseAA_value_tmp = PseAA_value(:,i);
    PseAA_value(:,i) = (PseAA_value_tmp-mean(PseAA_value_tmp))./std(PseAA_value_tmp,1);
end

% load data
%if(strcmp(data_path(end-5:end),'.fasta'))
%    [~,seq] = fastaread(data_path);
%else
%    error('please input the data in .fasta file');
%end
%[~,seq] = fastaread(data_path);
seq = importdata(data_path);
if(type == 1)
    data = zeros(length(seq),20+lambda);
elseif(type == 2)
    data = zeros(length(seq),20+2*lambda);
end

for i = 1:length(seq)
    seq_tmp = seq{i};
    seq_tmp = upper(seq_tmp);
    freq = zeros(20,1);
    for j = 1:20
        freq(j) = sum(seq_tmp == protein(j));
    end
    freq_sum = sum(freq);
    freq = freq./freq_sum;
    freq_sum = 1;
    seq_num = seq2num(seq_tmp,protein);
    theta = PseAA_cal(seq_num,PseAA_value,lambda,type);
    theta_sum = sum(theta);
    data_tmp = zeros(1,20+length(theta));
    for j = 1:20
        data_tmp(j) = freq(j)./(freq_sum+weight*theta_sum);
    end
    for j = 1:length(theta)
        data_tmp(20+j) = weight*theta(j)./(freq_sum+weight*theta_sum);
    end
    data(i,:) = data_tmp;
end
end

function theta = PseAA_cal(seq_num,PseAA_value,lambda,type)
seq_len = length(seq_num);
if(type == 1)
    theta = zeros(lambda,1);
    for j = 1:lambda
        seq_numj = [seq_num(1:end-j);seq_num(j+1:end)];
        cj = 0;
        for k = 1:size(seq_numj,2)
            seq_numj_tmp = seq_numj(:,k);
            cj = cj+mean((PseAA_value(seq_numj_tmp(1),:)-PseAA_value(seq_numj_tmp(2),:)).^2);
        end
        theta(j) = cj./(seq_len-j);
    end
elseif(type == 2)
    PseAA_value2 = PseAA_value.^2;
    theta = zeros(2*lambda,1);
    for j = 1:lambda
        seq_numj = [seq_num(1:end-j);seq_num(j+1:end)];
        cj = 0;
        cj2 = 0;
        for k = 1:size(seq_numj,2)
            seq_numj_tmp = seq_numj(:,k);
            cj = cj+mean(PseAA_value(seq_numj_tmp(1),:).*PseAA_value(seq_numj_tmp(2),:));
            cj2 = cj2+mean(PseAA_value2(seq_numj_tmp(1),:).*PseAA_value2(seq_numj_tmp(2),:));
        end
        theta(j*2-1) = cj./(seq_len-j);
        theta(j*2) = cj./(seq_len-j);
    end
end
end    

function seq_num = seq2num(seq,protein)
seq_num = zeros(size(seq));
for i = 1:20
    seq_num(seq == protein(i)) = i;
end
end